package com.vks;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.applet.*;
import java.net.*;
import java.util.*;

import com.vks.*;

public class alarmForm extends JDialog implements ActionListener { 
 Container pcont;  Box hbox,vbox; String tt,lt; JTextField inpf; JButton b1,b2,b3; 
 AudioClip ac; GregorianCalendar dati;
 //=============== 
 public alarmForm(){ super(MyPro.parent());
  setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
  setTitle("Alarm off"); setResizable(false); setModal(false);
  inpf = new JTextField(datetime());
  vbox = Box.createVerticalBox(); 
  hbox = Box.createHorizontalBox(); hbox.add(inpf); vbox.add(hbox);
  vbox.add(Box.createVerticalStrut(10));
  hbox = Box.createHorizontalBox();
  b1 = new JButton("OK"); b1.setActionCommand("ok"); b1.addActionListener(this);
  b2 = new JButton("Cancel"); b2.setActionCommand("ca"); b2.addActionListener(this);
  b3 = new JButton("Exit"); b3.setActionCommand("ex"); b3.addActionListener(this);
  hbox.add(Box.createHorizontalStrut(5));
  hbox.add(b1); hbox.add(Box.createHorizontalStrut(5)); 
  hbox.add(b2); hbox.add(Box.createHorizontalStrut(5));
  hbox.add(b3); hbox.add(Box.createHorizontalStrut(5));
  vbox.add(hbox); 
  vbox.add(Box.createVerticalStrut(10));
  pcont = getContentPane();
  pcont.add(Box.createVerticalStrut(5), BorderLayout.NORTH);
  pcont.add(Box.createHorizontalStrut(5), BorderLayout.WEST);
  pcont.add(vbox, BorderLayout.CENTER);
  pcont.add(Box.createHorizontalStrut(5), BorderLayout.EAST);
  pcont.add(Box.createVerticalStrut(5), BorderLayout.SOUTH); pack(); 
  setLocationRelativeTo(null); 
  this.setVisible(true); 
 }
 public void actionPerformed(ActionEvent e) {
  if( "ok".equals(e.getActionCommand()) ){setTitle("Alarm on"); onpro();}
  if( "ca".equals(e.getActionCommand()) ){setTitle("Alarm off"); if( ac != null ){ac.stop();}}
  if( "ex".equals(e.getActionCommand()) ){if( ac != null ){ac.stop();} this.setVisible(false);}
 }

 private void onpro(){ lt=inpf.getText(); tt=" ";
  while( !tt.equals(lt) ){
   try{Thread.sleep(500);}catch(InterruptedException e){e.printStackTrace();}
   tt = datetime();
  } 
  ac = Applet.newAudioClip(getClass().getResource("/reso/alarm.mid")); if( ac != null ){ac.loop();}
 }

 private String datetime(){
  int nye,nmo,nda,nho,nmi; String tt,sme,smi;
  dati = new GregorianCalendar();
  nye = dati.get(Calendar.YEAR); nmo = dati.get(Calendar.MONTH)+1;
  nda = dati.get(Calendar.DAY_OF_MONTH); nho = dati.get(Calendar.HOUR_OF_DAY);
  nmi = dati.get(Calendar.MINUTE);
  if( nmo < 10 ){ sme="-0"; } else { sme="-"; }
  if( nmi < 10 ){ smi=":0"; } else { smi=":"; }
  tt=""+nda+sme+nmo+"-"+nye+" "+nho+smi+nmi; 
  return tt;
 }

}