package com.vku;

import java.io.*;
import java.util.*;
import javax.swing.*;
import com.vku.*;

public class xmdl{
 public xmdl() {
  int n,nh; double[] a,r,rc; String txt;
  File fv = new File("tmp/inm.txt"); txt=genPro.fileToText(fv); 
  if(txt == null){txt="input file <inm> is incorrect"; message(txt); return;} 
  a=genPro.textToNumb(txt,1); nh=(int)a[0]; 
  if(nh == 0){nh=4; fv = new File("tmp/inmc.txt"); txt=genPro.fileToText(fv); r=genPro.textToNumb(txt,144);}
  else{n=10+2*nh; a=genPro.textToNumb(txt,n); r=xmdmat(a); genPro.numbToFile(r,"tmp/outm.dat",1);}
  fv = new File("tmp/inc.txt"); txt=genPro.fileToText(fv); 
  if(txt == null){txt="input file <inc> is incorrect"; message(txt); return;}
  a=genPro.textToNumb(txt,10+nh); rc=xmdcal(a,r); genPro.numbToFile(rc,"tmp/outc.dat",3);
 }

 private void message(String mess){
  JOptionPane.showMessageDialog(null, mess, "Error", JOptionPane.ERROR_MESSAGE);
 }

 private double[] xmdcal(double[] b, double[] r){
  int j,jb,k,l,l2,lh,lt1,lt2,n,nb,nh,nn,nt1,nt2; String txt;
  double dt1,dt2,c,cc,c1,h,fir,s,ss,t1,t2,t1f,t2f,tt1,tt2,tc;
  double s1,s2,s3,s4,s5,s6,s7,s8,bp,bs,br,bi,o,u; 
  double[] ar,ard,ai,g,d,v,v1,er,ei,res,re; double[][] co;
  n=r.length; s=n; nh=(int)(Math.sqrt(2.*s+1.)-1.)/4; n=2*nh; nn=n*n;
  ar=new double[nn]; ai=new double[nn]; g=new double[nh]; co=new double[3][nh];
  d=new double[nn]; ard=new double[n]; er=new double[n]; ei=new double[n];
  for(k=0; k < nn; k++){ar[k]=r[k]; ai[k]=r[k+nn];} j=2*nn;
  for(k=0; k < nh; k++){g[k]=r[j]; j++;}
  for(k=0; k < nh; k++){for(l=0; l < 3; l++){co[l][k]=r[j]; j++;}}
  for(k=0; k < n; k++){ard[k]=ar[k*n+k];}
  c1=0.0174532925; fir=b[1]*c1; c=Math.cos(fir); s=Math.sin(fir);
  fir=b[2]*c1; cc=Math.cos(fir); ss=Math.sin(fir); dt1=0.; dt2=0.;
  nt2=(int)b[8]; t2f=b[6]; if(nt2 > 1){dt2=(b[7]-t2f)/(nt2-1);} 
  nt1=(int)b[5]; t1f=b[3]; if(nt1 > 0){dt1=(b[4]-t1f)/nt1; t1f+=dt1/2.;} 
  k=8*nt1*nt2; re=new double[k]; for(j=0; j < k; j++){re[j]=0.;}
  k=0; nb=(int)(2.*b[0]); tc=b[9]/2;
  for(lt2=0; lt2 < nt2; lt2++){tt2=t2f+lt2*dt2;
   for(lt1=0; lt1 < nt1; lt1++){tt1=t1f+lt1*dt1;
    t1=tt1*c-tt2*s; t2=tt1*s+tt2*c; d=genPro.vpart(ar,0,nn);
    for(lh=0; lh < nh; lh++){h=co[0][lh]*t1+co[1][lh]*(t2+b[10+lh]);
     for(l2=0; l2 < 2; l2++){l=2*lh+l2; d[l*n+l]=ard[l]-h;
    }} res=genPro.disym(d); v=genPro.vpart(res,0,nn); er=genPro.vpart(res,nn,n);
    u=0.; for(j=0; j < nn; j++){u+=v[j];}
    if(u == 0.){txt="dicom fails at "+lt1+", "+lt2+"point"; message(txt); return re;}
    d=genPro.mmult(ai,v); v1=genPro.mtran(v); d=genPro.mmult(v1,d);
    for(j=0; j < n; j++){ei[j]=d[j*n+j];}
    s1=0.; s2=0.; s3=0.; s4=0.; s5=0.; s6=0.; s7=0.; s8=0.;
    for(j=0; j < n; j++){jb=j*n; l=jb+1; bp=v[jb]*cc+v[l]*ss; bs=v[l]*cc-v[jb]*ss;
     c1=Math.exp(-ei[j]*tc); o=er[j]*tc; br=c1*Math.cos(o); bi=c1*Math.sin(o);
     l=jb+nb; c1=v[l]; o=v[l+1]; u=c1*bp; s1+=u*br; s2+=u*bi; u=o*bp; s3+=u*br; s4+=u*bi;
     u=c1*bs; s5+=u*br; s6+=u*bi; u=o*bs; s7+=u*br; s8+=u*bi;
    } re[k]=s1; re[k+1]=s2; re[k+2]=s3; re[k+3]=s4; re[k+4]=s5; re[k+5]=s6; re[k+6]=s7; re[k+7]=s8; k+=8;
  }}  return re; 
 }

 private double[] xmdmat(double[] b){
  int i,ii,j,l,l1,l2,l3,l4,l5,ll,k,k1,m,n,nh,nn; double c,csp,f,f1,f2,h,h1,o,rr,qp,s,s1,t0; 
  int[] ia; double[] a,a1,a4,a5,z,z1,u,vn,g,res; double[][] p,co;  
  vn = new double[3]; z=new double[4]; z1=new double[4];
  nh=(int)b[0]; c=0.0174532925; t0=b[1]*c; f1=b[2]*c; f2=b[3]*c; rr=b[4]; qp=b[5]; csp=b[6]; s1=0.;
  vn[0]=b[7]; vn[1]=b[8]; vn[2]=b[9]; n=2*nh; i=3*nh; p=new double[3][i]; co=new double[3][nh];
  nn=n*n; a=new double[nn]; a1=new double[nn]; a4=new double[nn]; a5=new double[nn];
  g=new double[nh]; f=0.; s=Math.sin(t0); c=Math.cos(t0); k=0;
  for(l=0; l < nh; l++){h=Math.cos(f); h1=Math.sin(f);
   p[0][l]=c*h; p[1][l]=c*h1; p[2][l]=s; m=l+nh;
   p[0][m]=h1; p[1][m]=-h; p[2][m]=0.; m += nh;
   p[0][m]=s*h; p[1][m]=s*h1; p[2][m]=-c;
   if(k == 0){k++; f += f1;}else{k=0; f += f2;} }
  for(l=0; l < nh; l++){l1=l+nh; ia=index(l,0,n); u=xrpm(l,0,p); z[0]=u[0]; z1[0]=u[1];
   co[0][l]=rr*(z[0]-1.); u=xrpm(l1,0,p); z[1]=u[0]; z1[1]=u[1]; j=nh;
   u=xrpm(l,j,p); z[2]=u[0]; z1[2]=u[1]; co[1][l]=rr*z[2]; co[2][l]=0.;
   u=xrpm(l1,j,p); z[3]=u[0]; z1[3]=u[1]; k=2*l+10; k1=k+1;
   for(m=0; m < 4; m++){l2=ia[m]; a[l2]=b[k]*z[m]; a1[l2]=b[k1]*z[m]; a4[l2]=b[k1]*z1[m];}
   if(f2 != f1 && l > 0){u=xrpm(l,1,p); z[0]=u[0]; z1[0]=u[1]; u=xrpm(l1,1,p); z[1]=u[0]; z1[1]=u[1];
    j=nh+1; u=xrpm(l,j,p); z[2]=u[0]; z1[2]=u[1]; u=xrpm(l1,j,p); z[3]=u[0]; z1[3]=u[1];
    for(m=0; m < 4; m++){l2=ia[m]+2*n; l3=nh+2-l; if(l3 > nh-1){l3=0;} if(l == 2 && nh == 3){l3=3;} 
     k=2*l3+10; k1=k+1; a[l2]=b[k]*z[m]; a1[l2]=b[k1]*z[m]; a4[l2]=b[k1]*z1[m];
  }}} ii=5; if(f1 == f2){ii=3;}
  for(l=ii; l <= n; l++){l2=(l-1)*n; l3=(l-ii)*n;
   for(l1=l; l1 <= n; l1++){l4=l1+l2; l5=l1+l3-ii+1; i=l4-1; j=l5-1; a[i]=a[j]; a1[i]=a1[j]; a4[i]=a4[j];
  }}
  for(l=0; l < nn; l++){a1[l]=a1[l]*(1.-qp)+qp*a4[l]-1.e-4*csp*a[l];} vn=genPro.vunit(vn);
  for(l=0; l < nh; l++){m=l+n; o=0.; for(k=0; k < 3; k++){o += p[k][m]*vn[k];} g[l]=o;
   for(k=0; k < 3; k++){co[k][l] /= g[l];} }
  for(l=0; l < nh; l++){
   for(m=0; m < nh; m++){h=g[l]*g[m]; s=1./Math.sqrt(Math.abs(h));
    if(h > 0.){if(g[l] < 0.){s=-s;} s1=0;}else{s1=s; s=0.;} ia=index(m,l,n);
    for(j=0; j < 4; j++){k=ia[j]; a4[k]=s*a[k]+s1*a1[k]; a5[k]=s*a1[k]-s1*a[k];
  }}}
  for(l=2; l <= n; l++){l2=(l-1)*n; l3=l; ll=l-1;
   for(l1=1; l1 <= ll; l1++){l4=l1+l2; i=l4-1; j=l3-1; a4[i]=a4[j]; a5[i]=a5[j]; l3 += n;
  }} i=nh*(8*nh+4); res = new double[i];
  for(k=0; k < nn; k++){res[k]=a4[k]; res[k+nn]=a5[k];} j=2*nn;
  for(k=0; k < nh; k++){res[j]=g[k]; j++;}
  for(k=0; k < nh; k++){for(l=0; l < 3; l++){res[j]=co[l][k]; j++;}}
  return res; 
 }
 
 private int[] index(int m, int n, int k){
  int m2,n2; int[] i = new int[4]; m2=2*m; n2=2*n; 
  i[0]=m2+k*n2; i[1]=i[0]+1; i[2]=i[0]+k; i[3]=i[1]+k;  
  return i;  
 }
 
 private double[] xrpm(int i1, int i2, double[][] p){
  int i,i4,i5,j,n,nh; double h,h1,h2,h3; i=p[0].length; nh=i/3; n=2*nh;
  j=i1+n; if(j < i){i4=j;}else{i4=j-nh;} j=i2+n; if(j < i){i5=j;}else{i5=j-nh;}
  h=0.; h1=0.; h2=0.; h3=0.;
  for(i=0; i < 3; i++){h += p[i][i1]*p[i][i2];
   h1 += p[i][i4]*p[i][i5]; h2 += p[i][i1]*p[i][i5]; h3 += p[i][i4]*p[i][i2];
  } double[] u = new double[2]; u[0]=h; u[1]=h*h1+h2*h3;
  return u;
 }

}
/*
 b       xmdmat  10      ,
       .         ,   .  10 == nh,t0,f1,f2,rr,qp,csp,v[3].      b  10  .  ,   4-    4  ,   ,   10+2*nh .   s=nh*(8*nh+4) .  


  
vpart --  n       

mtran --   ,    

mmult --      ,    

disym --    ;          n*n,  ,   n    ;     ,       ,   ,   n  . 

fileToText --     

textToNumb --    n    double,   ,         

numbToText --   ,     10   ,         ,      10000  ,  .  n         . ,    .

textToFile --     

mdmat --     .  
nh --  
ar[n,n] --  , n=2*nh
ai[n,n] --  
g[nh] --   gamma_nh
co[3,nh] --            ,
       (  )
         ,   .   9 ,           ,   nh     sf,    ar,ai,g,co, s=sf/4, s=nh*(8*nh+4), nh=[sqr(2*s+1)-1]/4.

mdcalc --  ,      ,  
     
nb --    .
ang ang --       ()
ang pol --      
firt, last, nt --     
firf, lasf, nf --     
tc -- a 

                    ,  8     .    double.

*/