package com.vku;

import java.io.*;
import java.util.*;
import javax.swing.*;
import com.vku.*;
import com.vkm.*;

public class xmdswt{

 public xmdswt(){
  int k,key,n,n1,nv,nh; double[] a,r,rc; String txt = null; key=0; File fv = new File("data/inp-xmd.txt"); 
  if( fv.exists() ){key=1; txt=genPro.fileToText(fv); 
   if(txt == null){txt="input file <inp-xmd> is incorrect"; message(txt); return;} 
   a=genPro.textToNumb(txt,2); nv=(int)a[0];}
  else{a = new double[2]; a[0]=mi.da[1]; a[1]=mi.da[2]; nv=(int)a[0];}
  switch(nv){
   case 1: nh=(int)a[1]; n=11+2*nh; 
    if(key == 1){a=genPro.textToNumb(txt,n);}
    else{a = new double[n]; for(k=0; k < n; k++){a[k]=mi.da[k+1];}}
    r=xmdmat(a); 
    if(key == 1){genPro.numbToFile(r,"data/xmd-mat.dat",3);}
    else{n=r.length; for(k=0; k < n; k++){mi.da[k+1]=r[k];}} break;
   case 2: n=12;
    if(key == 1){a=genPro.textToNumb(txt,n);}
    else{a = new double[n]; for(k=0; k < n; k++){a[k]=mi.da[k+1];}}
    fv = new File("data/xmd-mat.dat");
    if( fv.exists() ){n1=(int)fv.length()/4; r=genPro.fileToNumb("data/xmd-mat.dat",0,n1,3);}
    else{n1=(int)mi.da[n+1]; r = new double[n1]; for(k=0; k < n1; k++){r[k]=mi.da[k+n+2];}}
    xmdcal(a,r); break;
   case 3: nh=(int)a[1]; n=13+7*nh; a=genPro.textToNumb(txt,n); xmdres(a); break;
  }
 }

 private void message(String mess){
  JOptionPane.showMessageDialog(null, mess, "Error", JOptionPane.ERROR_MESSAGE);
 }

 private void xmdcal(double[] b, double[] r){
  int j,jb,k,k1,k1t,k2,l,l2,lh,lt1,lt2,n,nar,nb,nbc,nh,nn,nt1,nt2,ntt; String txt,txt1;
  double dt1,dt2,c,cc,c1,h,fir,s,ss,t1,t2,t1f,t2f,tt1,tt2,tc;
  double s1,s2,s3,s4,s5,s6,s7,s8,bp,bs,br,bi,o,u; 
  double[] ar,ard,ai,g,d,v,v1,er,ei,res,sap,sas; double[][] co;
  n=r.length; s=n; nh=(int)(Math.sqrt(2.*s+1.)-1.)/4; n=2*nh; nn=n*n;
  ar=new double[nn]; ai=new double[nn]; g=new double[nh]; co=new double[3][nh];
  d=new double[nn]; ard=new double[n]; er=new double[n]; ei=new double[n];
  for(k=0; k < nn; k++){ar[k]=r[k]; ai[k]=r[k+nn];} j=2*nn;
  for(k=0; k < nh; k++){g[k]=r[j]; j++;}
  for(k=0; k < nh; k++){for(l=0; l < 3; l++){co[l][k]=r[j]; j++;}}
  for(k=0; k < n; k++){ard[k]=ar[k*n+k];}
  c1=0.0174532925; fir=b[1]*c1; c=Math.cos(fir); s=Math.sin(fir);
  fir=b[2]*c1; cc=Math.cos(fir); ss=Math.sin(fir); dt1=0.; dt2=0.; 
  nar=(int)b[9]; nbc=(int)b[10]; tc=b[11]/2;
  nt2=(int)b[8]; t2f=b[6]; if(nt2 > 1){dt2=(b[7]-t2f)/(nt2-1);} 
  nt1=(int)b[5]; t1f=b[3]; if(nt1 > 1){dt1=(b[4]-t1f)/(nt1-1);} 
  ntt=nt1*nt2; k1t=ntt*n; sap=new double[nh]; sas=new double[nh];
  for(lt2=0; lt2 < nt2; lt2++){tt2=t2f+lt2*dt2;
   for(lt1=0; lt1 < nt1; lt1++){tt1=t1f+lt1*dt1;
    t1=tt1*c-tt2*s; t2=tt1*s+tt2*c; d=genPro.vpart(ar,0,nn);
    for(lh=0; lh < nh; lh++){h=co[0][lh]*t1+co[1][lh]*t2;
     for(l2=0; l2 < 2; l2++){l=2*lh+l2; d[l*n+l]=ard[l]-h;
    }} res=genPro.disym(d); v=genPro.vpart(res,0,nn); er=genPro.vpart(res,nn,n);
    u=0.; for(j=0; j < nn; j++){u+=v[j];}
    if(u == 0.){txt="dicom fails at "+lt1+", "+lt2+"point"; message(txt); return;}
    d=genPro.mmult(ai,v); v1=genPro.mtran(v); d=genPro.mmult(v1,d);
    if(tc == 0){
     for(j=0; j < n; j++){ei[j]=d[j*n+j]; jb=j*n; l=jb+1;
      bp=v[jb]*cc+v[l]*ss; bs=v[l]*cc-v[jb]*ss; s1=0.; s2=0.;
      for(nb=0; nb < nh; nb++){l=jb+2*nb; c1=v[l]; o=v[l+1];
       u=c1*c1+o*o; s1=s1-co[0][nb]*u; s2=s2-co[1][nb]*u;
      } nb=nbc; l=jb+2*nb; c1=v[l]; o=v[l+1]; k1=1+lt1+nt1*(lt2+j*nt2); mi.da[k1]=c1*bp; k1 += k1t; mi.da[k1]=c1*bs;
      k1 += k1t; mi.da[k1]=o*bp; k1 += k1t; mi.da[k1]=o*bs; k1 += k1t; mi.da[k1]=er[j]; k1 += k1t; mi.da[k1]=ei[j];
      k1 += k1t; mi.da[k1]=s1; k1 += k1t; mi.da[k1]=s2;
    }}
    else if(nbc >= 0){ for(j=0; j < n; j++){ei[j]=d[j*n+j];}
     s1=0.; s2=0.; s3=0.; s4=0.; s5=0.; s6=0.; s7=0.; s8=0.;
     for(j=0; j < n; j++){jb=j*n; l=jb+1; bp=v[jb]*cc+v[l]*ss; bs=v[l]*cc-v[jb]*ss;
      c1=Math.exp(-ei[j]*tc); o=er[j]*tc; br=c1*Math.cos(o); bi=c1*Math.sin(o);
      l=jb+2*nbc; c1=v[l]; o=v[l+1]; u=c1*bp; s1+=u*br; s2+=u*bi; u=o*bp; s3+=u*br; s4+=u*bi;
      u=c1*bs; s5+=u*br; s6+=u*bi; u=o*bs; s7+=u*br; s8+=u*bi;
     } k1=1+lt1+nt1*lt2; mi.da[k1]=s1; k1+=ntt; mi.da[k1]=s2; k1+=ntt; mi.da[k1]=s3; k1+=ntt; mi.da[k1]=s4;
     k1+=ntt; mi.da[k1]=s5; k1+=ntt; mi.da[k1]=s6; k1+=ntt; mi.da[k1]=s7; k1+=ntt; mi.da[k1]=s8;
    }
    else{ for(j=0; j < n; j++){ei[j]=2.*d[j*n+j];}
     for(nb=0; nb < nh; nb++){sap[nb]=0.; sas[nb]=0.;} s1=0.; s2=0.;
     for(j=0; j < n; j++){jb=j*n; l=jb+1; bp=v[jb]*cc+v[l]*ss; bs=v[l]*cc-v[jb]*ss;
      c1=Math.exp(-ei[j]*tc); bp=bp*bp; bs=bs*bs; s1+=bp*c1; s2+=bs*c1;
      for(nb=0; nb < nh; nb++){l=jb+2*nb; br=v[l]; bi=v[l+1]; br=br*br+bi*bi; 
       sap[nb]+=br*bp*c1; sas[nb]+=br*bs*c1;
     }} k1=1+lt1+nt1*lt2; mi.da[k1]=s1; k1+=ntt; mi.da[k1]=s2; lh=ntt*nh;
     for(nb=0; nb < nh; nb++){k1+=ntt; mi.da[k1]=sap[nb]; k2=k1+lh; mi.da[k2]=sas[nb]; 
    }}
  }}
  if(nar >= 0){
   txt="data/a"+nar; if(nar < 10){txt="data/a0"+nar;} txt1=".dat"; txt=txt+txt1; 
   File fs = new File(txt); if(tc == 0){n=k1t*8;}else if(nbc >= 0){n=ntt*8;}else{n=ntt*2*(nh+1);}
   try{
    BufferedOutputStream bout = new BufferedOutputStream(new FileOutputStream(fs));
    DataOutputStream dout = new DataOutputStream(bout);
    for( k=1; k <= n; k++ ){dout.writeDouble(mi.da[k]);} 
    bout.flush(); dout.close(); 
   }catch(IOException ex){ex.printStackTrace();} 
 }}

 private double[] xmdmat(double[] b){
  int i,ii,j,l,l1,l2,l3,l4,l5,ll,k,k1,m,n,nh,nn; double c,csp,f,f1,f2,h,h1,o,rr,qp,s,s1,t0; 
  int[] ia; double[] a,a1,a4,a5,z,z1,u,vn,g,res; double[][] p,co;  
  vn = new double[3]; z=new double[4]; z1=new double[4];
  nh=(int)b[1]; c=0.0174532925; t0=b[2]*c; f1=b[3]*c; f2=b[4]*c; rr=b[5]; qp=b[6]; csp=b[7]; s1=0.;
  vn[0]=b[8]; vn[1]=b[9]; vn[2]=b[10]; n=2*nh; i=3*nh; p=new double[3][i]; co=new double[3][nh];
  nn=n*n; a=new double[nn]; a1=new double[nn]; a4=new double[nn]; a5=new double[nn];
  g=new double[nh]; f=0.; s=Math.sin(t0); c=Math.cos(t0); k=0;
  for(l=0; l < nh; l++){h=Math.cos(f); h1=Math.sin(f);
   p[0][l]=c*h; p[1][l]=c*h1; p[2][l]=s; m=l+nh;
   p[0][m]=h1; p[1][m]=-h; p[2][m]=0.; m += nh;
   p[0][m]=s*h; p[1][m]=s*h1; p[2][m]=-c;
   if(k == 0){k++; f += f1;}else{k=0; f += f2;} }
  for(l=0; l < nh; l++){l1=l+nh; ia=index(l,0,n); u=xrpm(l,0,p); z[0]=u[0]; z1[0]=u[1];
   co[0][l]=rr*(z[0]-1.); u=xrpm(l1,0,p); z[1]=u[0]; z1[1]=u[1]; j=nh;
   u=xrpm(l,j,p); z[2]=u[0]; z1[2]=u[1]; co[1][l]=rr*z[2]; co[2][l]=0.;
   u=xrpm(l1,j,p); z[3]=u[0]; z1[3]=u[1]; k=2*l+11; k1=k+1;
   for(m=0; m < 4; m++){l2=ia[m]; a[l2]=b[k]*z[m]; a1[l2]=b[k1]*z[m]; a4[l2]=b[k1]*z1[m];}
   if(f2 != f1 && l > 0){u=xrpm(l,1,p); z[0]=u[0]; z1[0]=u[1]; u=xrpm(l1,1,p); z[1]=u[0]; z1[1]=u[1];
    j=nh+1; u=xrpm(l,j,p); z[2]=u[0]; z1[2]=u[1]; u=xrpm(l1,j,p); z[3]=u[0]; z1[3]=u[1];
    for(m=0; m < 4; m++){l2=ia[m]+2*n; l3=nh+2-l; if(l3 > nh-1){l3=0;} if(l == 2 && nh == 3){l3=3;} 
     k=2*l3+11; k1=k+1; a[l2]=b[k]*z[m]; a1[l2]=b[k1]*z[m]; a4[l2]=b[k1]*z1[m];
  }}} ii=5; if(f1 == f2){ii=3;}
  for(l=ii; l <= n; l++){l2=(l-1)*n; l3=(l-ii)*n;
   for(l1=l; l1 <= n; l1++){l4=l1+l2; l5=l1+l3-ii+1; i=l4-1; j=l5-1; a[i]=a[j]; a1[i]=a1[j]; a4[i]=a4[j];
  }}
  for(l=0; l < nn; l++){a1[l]=a1[l]*(1.-qp)+qp*a4[l]-1.e-4*csp*a[l];} vn=genPro.vunit(vn);
  for(l=0; l < nh; l++){m=l+n; o=0.; for(k=0; k < 3; k++){o += p[k][m]*vn[k];} g[l]=o;
   for(k=0; k < 3; k++){co[k][l] /= g[l];} }
  for(l=0; l < nh; l++){
   for(m=0; m < nh; m++){h=g[l]*g[m]; s=1./Math.sqrt(Math.abs(h));
    if(h > 0.){if(g[l] < 0.){s=-s;} s1=0;}else{s1=s; s=0.;} ia=index(m,l,n);
    for(j=0; j < 4; j++){k=ia[j]; a4[k]=s*a[k]+s1*a1[k]; a5[k]=s*a1[k]-s1*a[k];
  }}}
  for(l=2; l <= n; l++){l2=(l-1)*n; l3=l; ll=l-1;
   for(l1=1; l1 <= ll; l1++){l4=l1+l2; i=l4-1; j=l3-1; a4[i]=a4[j]; a5[i]=a5[j]; l3 += n;
  }} i=nh*(8*nh+4); res = new double[i];
  for(k=0; k < nn; k++){res[k]=a4[k]; res[k+nn]=a5[k];} j=2*nn;
  for(k=0; k < nh; k++){res[j]=g[k]; j++;}
  for(k=0; k < nh; k++){for(l=0; l < 3; l++){res[j]=co[l][k]; j++;}}
  return res; 
 }
 
 private int[] index(int m, int n, int k){
  int m2,n2; int[] i = new int[4]; m2=2*m; n2=2*n; 
  i[0]=m2+k*n2; i[1]=i[0]+1; i[2]=i[0]+k; i[3]=i[1]+k;  
  return i;  
 }
 
 private double[] xrpm(int i1, int i2, double[][] p){
  int i,i4,i5,j,n,nh; double h,h1,h2,h3; i=p[0].length; nh=i/3; n=2*nh;
  j=i1+n; if(j < i){i4=j;}else{i4=j-nh;} j=i2+n; if(j < i){i5=j;}else{i5=j-nh;}
  h=0.; h1=0.; h2=0.; h3=0.;
  for(i=0; i < 3; i++){h += p[i][i1]*p[i][i2];
   h1 += p[i][i4]*p[i][i5]; h2 += p[i][i1]*p[i][i5]; h3 += p[i][i4]*p[i][i2];
  } double[] u = new double[2]; u[0]=h; u[1]=h*h1+h2*h3;
  return u;
 }

 private void xmdres(double[] b){
  int i,i1,i2,i3,i4,ib,j,ja,jb,k,k1,k2,ka,kx,ky,l,m,mx1,mx2,my1,my2,n,n1,n2,n3,na,nar,nb,nh,nt1,nt2,nt22,nt27,nx,ny; 
  double dt1,dt2,e11,e22,e12,dx,dy,o,pad,s1,s2,t,t1f,t2f,x1,x2,xb,y1,y2,yb,z,zK,C1,C2,C3,K;
  double[] er,ei,e1,e2,psi,tmp,u1,u2; String txt,txt1; double[][] res; 
  na=(int)b[1]; nh=(int)b[2]; nb=(int)b[3]; t=b[4]/2; z=b[5]; K=b[6]; zK=z/K; dx=1; dy=1; xb=b[7]; nx=(int)b[9]; 
  if(nx > 1){dx=(b[8]-xb)/(nx-1);} yb=b[10]; ny=(int)b[12]; if(ny > 1){dy=(b[11]-yb)/(ny-1);} n=2*nh;
  n2=8*nx*ny; psi = new double[n2]; for(k=0; k < n2; k++){psi[k]=0.;} u1 = new double[23]; u2 = new double[8];
  for(ka=0; ka < na; ka++){ja=13+ka*7; nar=(int)b[ja]; dt1=0.; dt2=0.; nt2=(int)b[ja+6]; t2f=b[ja+4]; 
   if(nt2 > 1){dt2=(b[ja+5]-t2f)/(nt2-1);} nt1=(int)b[ja+3]; t1f=b[ja+1]; if(nt1 > 0){dt1=(b[ja+2]-t1f)/(nt1-1);}
   n3=nt1*nt2; n1=n3*n; res = new double[4][n1]; er = new double[n1]; ei = new double[n1]; e1 = new double[n1];
   e2 = new double[n1]; nt22=nt2-2; nt27=7*nt22; k=2*nt27; tmp = new double[k]; C2=1e4/(K*K); C1=C2/dt1; C2=C2/dt2; C3=1e2/K;
   txt="tmp/a"+nar; if(nar < 10){txt="tmp/a0"+nar;}
   for(k=0; k < 4; k++){k1=k+4*nb; txt1=""+k1+".dat"; 
    if(k1 < 10){txt1="0"+k1+".dat";} txt1=txt+txt1; res[k]=genPro.fileToNumb(txt1,0,n1,1);
   } k1=4*nh; txt1=txt+k1+".dat"; er=genPro.fileToNumb(txt1,0,n1,1); k1++; txt1=txt+k1+".dat"; 
   ei=genPro.fileToNumb(txt1,0,n1,1); k1++; txt1=txt+k1+".dat"; e1=genPro.fileToNumb(txt1,0,n1,1); k1++;
   txt1=txt+k1+".dat"; e2=genPro.fileToNumb(txt1,0,n1,1);
   for(j=0; j < n; j++){jb=n3*j; k=1; 
    for(l=1; l < nt2-1; l++){m=7*(l-1); i=jb+k+l*nt1; e11=0.5*C1*(e1[i+1]-e1[i-1]);
     e22=0.5*C2*(e2[i+nt1]-e2[i-nt1]); e12=0.25*(C1*(e2[i+1]-e2[i-1])+C2*(e1[i+nt1]-e1[i-nt1]));
     e11=e11*t-zK; e22=e22*t-zK; e12=e12*t; o=e11*e22-e12*e12; if(o > 0.){o=Math.sqrt(o); pad=0.;}
     else{o=Math.sqrt(Math.abs(o)); pad=-Math.PI/2;} o=Math.exp(-ei[i]*t)/o; 
     for(k2=0; k2 < 4; k2++){tmp[m+k2]=res[k2][i]*o;} tmp[m+4]=er[i]*t+pad;
      tmp[m+5]=0.01*z*(t1f+k*dt1)-e1[i]*t*C3; tmp[m+6]=0.01*z*(t2f+l*dt2)-e2[i]*t*C3;
    } 
    for(k=2; k < nt1-1; k++){
     for(l=1; l < nt2-1; l++){m=7*(l-1)+nt27; i=jb+k+l*nt1; e11=0.5*C1*(e1[i+1]-e1[i-1]);
      e22=0.5*C2*(e2[i+nt1]-e2[i-nt1]); e12=0.25*(C1*(e2[i+1]-e2[i-1])+C2*(e1[i+nt1]-e1[i-nt1]));
      e11=e11*t-zK; e22=e22*t-zK; e12=e12*t; o=e11*e22-e12*e12; if(o > 0.){o=Math.sqrt(o); pad=0.;}
      else{o=Math.sqrt(Math.abs(o)); pad=-Math.PI/2;} o=Math.exp(-ei[i]*t)/o; 
      for(k2=0; k2 < 4; k2++){tmp[m+k2]=res[k2][i]*o;} tmp[m+4]=er[i]*t+pad;
      tmp[m+5]=0.01*z*(t1f+k*dt1)-e1[i]*t*C3; tmp[m+6]=0.01*z*(t2f+l*dt2)-e2[i]*t*C3;
     } 
     for(l=0; l < nt22-1; l++){i2=7*l; i4=i2+7; i1=i2+nt27; i3=i1+7; 
      for(i=0; i < 7; i++){u1[i]=tmp[i1+i]; u1[i+7]=tmp[i2+i]; u1[i+14]=tmp[i3+i];} x1=1e99; y1=x1; x2=-x1; y2=x2; 
      for(i=0; i < 3; i++){o=u1[7*i+5]; if(x1 > o){x1=o;} if(x2 < o){x2=o;} o=u1[7*i+6]; if(y1 > o){y1=o;} if(y2 < o){y2=o;}}
      mx1=(int)Math.ceil((x1-xb)/dx); mx2=(int)Math.ceil((x2-xb)/dx); my1=(int)Math.ceil((y1-yb)/dy); my2=(int)Math.ceil((y2-yb)/dy);
      if(mx1 < 0){mx1=0;} if(mx2 > nx){mx2=nx;} if(my1 < 0){my1=0;} if(my2 > ny){my2=ny;}
      for(ky=my1; ky < my2; ky++){u1[22]=yb+ky*dy; 
       for(kx=mx1; kx < mx2; kx++){u1[21]=xb+kx*dx; u2=intpol(u1); m=8*(kx+ky*nx); 
        for(i=0; i < 8; i++){psi[m+i]+=u2[i];
      }}} 
      for(i=0; i < 7; i++){u1[i]=tmp[i4+i]; u1[i+7]=tmp[i2+i]; u1[i+14]=tmp[i3+i];} x1=1e99; y1=x1; x2=-x1; y2=x2; 
      for(i=0; i < 3; i++){o=u1[7*i+5]; if(x1 > o){x1=o;} if(x2 < o){x2=o;} o=u1[7*i+6]; if(y1 > o){y1=o;} if(y2 < o){y2=o;}}
      mx1=(int)Math.ceil((x1-xb)/dx); mx2=(int)Math.ceil((x2-xb)/dx); my1=(int)Math.ceil((y1-yb)/dy); my2=(int)Math.ceil((y2-yb)/dy);
      if(mx1 < 0){mx1=0;} if(mx2 > nx){mx2=nx;} if(my1 < 0){my1=0;} if(my2 > ny){my2=ny;}
      for(ky=my1; ky < my2; ky++){u1[22]=yb+ky*dy; 
       for(kx=mx1; kx < mx2; kx++){u1[21]=xb+kx*dx; u2=intpol(u1); m=8*(kx+ky*nx); 
        for(i=0; i < 8; i++){psi[m+i]+=u2[i];
      }}}
     } for(i=0; i < nt27; i++){tmp[i]=tmp[i+nt27];}
  }}} 
  n=nx*ny; u1 = new double[n]; u2 = new double[n]; C1=2.*Math.PI; C1=1/(C1*C1);
  for(ky=0; ky < ny; ky++){ib=nx*ky;
   for(kx=0; kx < nx; kx++){i=ib+kx; j=8*i; s1=0.; s2=0.;
    for(k=0; k < 4; k++){l=j+2*k; o=psi[l]; s1+=o*o; o=psi[l+1]; s2+=o*o;}
    u1[i]=s1*C1; u2[i]=s2*C1;
  }} genPro.numbToFile(u1,"tmp/intp.dat",1); genPro.numbToFile(u2,"tmp/ints.dat",1);
 }

 private double[] intpol(double[] b){
  int j,k; double a1,a2,a3,d,x0,x1,x2,x3,y0,y1,y2,y3,C,S;
  double[] r,u; r = new double[8]; u = new double[5];
  x1=b[5]; y1=b[6]; x2=b[12]; y2=b[13]; x3=b[19]; y3=b[20]; x0=b[21]; y0=b[22];
  x0-=x1; y0-=y1; x2-=x1; y2-=y1; x3-=x1; y3-=y1; d=x3*y2-x2*y3;
  a3=(x0*y2-y0*x2)/d; a2=(y0*x3-x0*y3)/d; a1=1.-a2-a3;
  if(a1 < 0. || a2 < 0. || a3 < 0.){for(k=0; k < 8; k++){r[k]=0.;}}
  else{for(k=0; k < 5; k++){u[k]=a1*b[k]+a2*b[k+7]+a3*b[k+14];}
   C=Math.cos(u[4]); S=Math.sin(u[4]); for(k=0; k < 4; k++){j=2*k; r[j]=u[k]*C; r[j+1]=u[k]*S;}}
  return r; 
 }

}
